AW: Dienst verzögert starten
Hi b3ll3roph0n (schwieriger Name
)
Deinen Rat, das Script nach dem Beispiel aus /etc/init.d/skeleton zu erstellen, hab ich befolgt und ich war erstaunt wie leicht es ging
Hab nur die Variablen verändert und sonst nix weiter machen müssen. Das freut mich natürlich als Anwender, weil ich nicht soviel Ahnung von Programmier- bzw. Scriptsprachen und deren Syntax habe.
Die Schleife mit sleep wird aus folgenden Grund so nicht funktionieren. Wenn ich den IRC-Server starte müssen mindestens 5-10s vergehen bevor Denora gestartet werden kann. Selbst wenn ich mit
Code:
ps aux |grep irc_unrealircd
den Dienst angezeigt bekomme heißt das nicht das Denora auch startet. Ich kann Dir nicht erklären woran das liegt, aber das ist die Erfahrung die ich gemacht habe. Die Schleife müßte anders herum geschrieben werden, das solange versucht wird Denora zu starten bis
Code:
ps aux |grep stats #stats ist der Dienst unter dem Denora läuft
einen wahren Rückgabewert liefert. Könntest Du mir helfen wie ich das realisiere?
Code:
#! /bin/sh
### BEGIN INIT INFO
# Provides: skeleton
# Required-Start: $local_fs $remote_fs
# Required-Stop: $local_fs $remote_fs
# Default-Start: 2
# Default-Stop: S 0 1 6
# Short-Description: Example initscript
# Description: This file should be used to construct scripts to be
# placed in /etc/init.d.
### END INIT INFO
# Do NOT "set -e"
# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/bin
DENORA_DIR=/srv/denora
DESC="Unreal32 IRC Statistiken"
NAME=stats
DAEMON=$DENORA_DIR/$NAME
DAEMON_ARGS=""
PIDFILE=$DENORA_DIR/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
# Exit if the package is not installed
[ -x '$DAEMON' ] || exit 0
# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions
#
# Function that starts the daemon/service
#
do_start()
{
# Return
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
|| return 1
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
$DAEMON_ARGS \
|| return 2
# Add code here, if necessary, that waits for the process to be ready
# to handle requests from services started subsequently which depend
# on this one. As a last resort, sleep for some time.
}
#
# Function that stops the daemon/service
#
do_stop()
{
# Return
# 0 if daemon has been stopped
# 1 if daemon was already stopped
# 2 if daemon could not be stopped
# other if a failure occurred
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
RETVAL="$?"
[ '$RETVAL' = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently. A last resort is to
# sleep for some time.
start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
[ '$?' = 2 ] && return 2
# Many daemons don't delete their pidfiles when they exit.
rm -f $PIDFILE
return "$RETVAL"
}
#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
#
# If the daemon can reload its configuration without
# restarting (for example, when it is sent a SIGHUP),
# then implement that here.
#
start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
return 0
}
case "$1" in
start)
[ '$VERBOSE' != no ] && log_daemon_msg "Starting $DESC" "$NAME"
do_start
case "$?" in
0|1) [ '$VERBOSE' != no ] && log_end_msg 0 ;;
2) [ '$VERBOSE' != no ] && log_end_msg 1 ;;
esac
;;
stop)
[ '$VERBOSE' != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
do_stop
case "$?" in
0|1) [ '$VERBOSE' != no ] && log_end_msg 0 ;;
2) [ '$VERBOSE' != no ] && log_end_msg 1 ;;
esac
;;
#reload|force-reload)
#
# If do_reload() is not implemented then leave this commented out
# and leave 'force-reload' as an alias for 'restart'.
#
#log_daemon_msg "Reloading $DESC" "$NAME"
#do_reload
#log_end_msg $?
#;;
restart|force-reload)
#
# If the "reload" option is implemented then remove the
# 'force-reload' alias
#
log_daemon_msg "Restarting $DESC" "$NAME"
do_stop
case "$?" in
0|1)
do_start
case "$?" in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;;
*)
# Failed to stop
log_end_msg 1
;;
esac
;;
*)
#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
exit 3
;;
esac
: